var isWhitelisted = "UNKNOWN";

// parameters to gCommonDialogParam.Get() are defined in nsPIPromptService.idl
var gCommonDialogParam = 
  window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);

var debugPasscardJS = false;
function debug(text) {
  if(debugPasscardJS) {
    dump("Passcard JS: " + text + "\n");
  }
}

function onProtectChanged(protectCheckBox) {
  gCommonDialogParam.SetInt(12, protectCheckBox.checked ? 1 : 0);
  debug("param(12)=" + (protectCheckBox.checked ? 1 : 0));
}

function checkWhitelist() {
  var realm = gCommonDialogParam.GetString(18);
  var scService = Components.classes["@mozilla.org/browser/sitecontrols-service;1"]
                                           .getService(Components.interfaces.nsISiteControlsService); 
  return (scService.getSiteTrustLevel("http://" + realm) == 0);  
}

function setCheckbox(aChkMsg, aChkValue)
{
  if (aChkMsg) {
    // XXX Would love to use hidden instead of collapsed, but the checkbox
    // fails to size itself properly when I do this.
    document.getElementById("checkboxContainer").removeAttribute("collapsed");
    
    var checkboxElement = document.getElementById("checkbox");
    setLabelForNode(checkboxElement, aChkMsg);
    checkboxElement.checked = aChkValue > 0;
    showFraudProtection();
  }
}

function setMasterpassword() {
  var set = false;
  
  var aCheckboxElement = document.getElementById("checkbox");
  //check if protect with master password and master password is not set
  if(aCheckboxElement.checked && !aCheckboxElement.disabled) {
    if(!IsMasterPasswordSet())  
    {
      // if master password already exists, pass empty string to use default text
    	var dialogTitle = GetMasterPasswordText();
    	var obj = new Object( );
    	obj.res = "";
    	    
    	window.openDialog("chrome://browser/content/pref/pref-masterpass.xul",
    		"_blank", "chrome,dialog,modal", dialogTitle,obj);
    	
    	set = (obj.res == "ok");
    	if(!set) {
    	  aCheckboxElement.checked = false;
    	}
    }
    else {
      set = true;
    }
  }
  
  return set;
}

function onCheckboxClick()
{
  gCommonDialogParam.SetInt(1, setMasterpassword() ? 1:0);    	
  showFraudProtection();
  checkFraudProtection();  
}

function checkFraudProtection() {
  var check1 = document.getElementById("checkbox");
  var check2 = document.getElementById("protectFromFraud");
  var oldValue = check2.checked;
  if(!check1.checked || document.getElementById("checkboxContainer2").collapsed) {
    check2.setAttribute("checked", false);
  }
  else if(isWhitelisted) {
    check2.setAttribute("checked", document.getElementById("checkbox").checked);
  }
  
  var newValue = check2.checked;
  if(oldValue != newValue) {
    onProtectChanged(check2);
  }
}

function showFraudProtection() {
    if(isWhitelisted == "UNKNOWN") {
      isWhitelisted = checkWhitelist();
    }
        
    var check2 = document.getElementById("protectFromFraud");
    var check1 = document.getElementById("checkbox");
    var toShow = !check1.disabled && check1.checked;
        
    if(!isWhitelisted && pmGetProtectWhitelistOnly()) {
      //document.getElementById("checkboxContainer2").setAttribute("collapsed", true);
      //return;
      toShow = false;
    }

    if(toShow) {
        check2.removeAttribute("disabled");
        document.getElementById("whatsthisLabel").removeAttribute("disabled");          
    }
    else {
        check2.setAttribute("disabled", true);
        document.getElementById("whatsthisLabel").disabled = true;           
    }
}

function setLabelForNode(aNode, aLabel, aIsLabelFlag)
{
  // This is for labels with possible accesskeys
  var accessKeyIndex;
  if (/^\&[^\&]/.test(aLabel)) { // access key is at the start
   accessKeyIndex = 0;
  } else {
    accessKeyIndex = aLabel.search(/[^\&]\&[^\&]/) + 1;
    if (accessKeyIndex == 0) {
      accessKeyIndex = -1; // magic value for no accesskey
    }
  }

  // If a character has an & before it, then it should become an accesskey
  if (accessKeyIndex >= 0 && accessKeyIndex < aLabel.length - 1) {
    // This will also cause the accesskey attribute to be set via xbl
    aNode.accessKey = aLabel.charAt(accessKeyIndex + 1);
    // Set the label to the string without the &
    aLabel = aLabel.substr(0, accessKeyIndex) + 
             aLabel.substr(accessKeyIndex + 1);
  }
  aLabel = aLabel.replace(/\&\&/g, "&");
  if (aIsLabelFlag) {    // Set text for <label> element
    aNode.setAttribute("value", aLabel);
  } else {    // Set text for other xul elements
    aNode.label = aLabel;
  }
}

// MERC JVL
// Handler for SNS enabled checkbox
function OnSNSEnabled(obj)
{
  gCommonDialogParam.SetInt(13, obj.checked ? 1 : 0);

  var bChecked = obj.checked;
  if (bChecked)
  {
    document.getElementById("checkbox").disabled = bChecked;
  }
  else
  {
    document.getElementById("checkbox").removeAttribute("disabled");
  }

  showFraudProtection();  

  var screenName = GetSNSScreenName();
  if (obj.checked && screenName.length > 0 && IsSNSAutoLogin(screenName))
    document.getElementById("dropdownMenulist").selectedIndex = kAutoLogin;		// kAutoLogin defined in passcard.js
}
