/* ***** BEGIN LICENSE BLOCK *****
 * Version: NPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Netscape Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mozilla Communicator client code.
 *
 * The Initial Developer of the Original Code is 
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Alec Flett  <alecf@netscape.com>
 *  Ben Goodger <ben@netscape.com>
 *  Blake Ross  <blakeross@telocity.com>
 *  Joe Hewitt <hewitt@netscape.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or 
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the NPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the NPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// parameters to gCommonDialogParam.Get() are defined in nsPIPromptService.idl

var kPromptDisplay = 0;
var kPromptAutoFill = 1;
var kPromptFillAndSubmit = 2;
var kPromptDoNothing = 3;

var gBrowser = null;
  
function showControls()
{
  // This is called before onload fires, so we can't be certain that any elements
  // in the document have their bindings ready, so don't call any methods/properties
  // here on xul elements that come from xbl bindings.
  
  gBrowser = document.getElementById("content");
  
  //Passcard name field
  initTextbox("name",4,6,false);
  
  debug("5 = " + gCommonDialogParam.GetString(5)+'\n');
  debug("6 text = " + gCommonDialogParam.GetString(6)+'\n');
  debug("7 text = " + gCommonDialogParam.GetString(7)+'\n');
  debug("8 = " + gCommonDialogParam.GetString(8)+'\n');
  debug("4 text = " + gCommonDialogParam.GetString(4)+'\n');
  debug("3 text = " + gCommonDialogParam.GetString(3)+'\n');
  debug("10 = " + gCommonDialogParam.GetString(10)+'\n');
  debug("11 text = " + gCommonDialogParam.GetString(11)+'\n');
  debug("12 text = " + gCommonDialogParam.GetString(12)+'\n');
  debug("13 = " + gCommonDialogParam.GetString(13)+'\n');
  debug("14 text = " + gCommonDialogParam.GetString(14)+'\n');
  debug("15 text = " + gCommonDialogParam.GetString(15)+'\n');
  debug("16 text = " + gCommonDialogParam.GetString(16)+'\n');
  debug("17 text = " + gCommonDialogParam.GetString(17)+'\n');
  debug("18 text = " + gCommonDialogParam.GetString(18)+'\n');
  debug("12 int = " + gCommonDialogParam.GetInt(12)+'\n');
  debug("13 int = " + gCommonDialogParam.GetInt(13)+'\n');
}

function updatePromptOnLoad()
{
  // set the window title
  window.title = gCommonDialogParam.GetString(12);

  // set the number of command buttons
  var nButtons = gCommonDialogParam.GetInt(2);
  var dialog = document.documentElement;
  switch (nButtons) {
    case 1:
      dialog.getButton("cancel").hidden = true;
      break;
    case 4:
      dialog.getButton("extra2").hidden = false;
    case 3:
      dialog.getButton("extra1").hidden = false;
  }

  // display the main text
  var messageText = gCommonDialogParam.GetString(0);
  var messageParent = document.getElementById("info.box");
  var messageParagraphs = messageText.split("\n");

  for (var i = 0; i < messageParagraphs.length; i++) {
    var descriptionNode = document.createElement("description");
    var text = document.createTextNode(messageParagraphs[i]);
    descriptionNode.appendChild(text);
    messageParent.appendChild(descriptionNode);
  }

  setElementText("info.header", gCommonDialogParam.GetString(3), true);

  // set the icon
  var iconElement = document.getElementById("info.icon");
  var iconClass = gCommonDialogParam.GetString(2);
  if (!iconClass)
    iconClass = "alert-icon";
  iconElement.setAttribute("class", iconElement.getAttribute("class") + " " + iconClass);

  switch (nButtons) {
    case 4:
      setLabelForNode(document.documentElement.getButton("extra2"), gCommonDialogParam.GetString(11));
      // fall through
    case 3:
      setLabelForNode(document.documentElement.getButton("extra1"), gCommonDialogParam.GetString(10));
      // fall through
    default:
    case 2:
      var string = gCommonDialogParam.GetString(9);
      if (string)
        setLabelForNode(document.documentElement.getButton("cancel"), string);
      // fall through
    case 1:
      string = gCommonDialogParam.GetString(8);
      if (string)
        setLabelForNode(document.documentElement.getButton("accept"), string);
      break;
  }

  // set default result to cancelled
  gCommonDialogParam.SetInt(0, 1); 

  // initialize the checkbox
  setCheckbox(gCommonDialogParam.GetString(1), gCommonDialogParam.GetInt(1));
  
  //initialize the radiobuttons
  setRadiobutton("radio0",gCommonDialogParam.GetString(13));
  setRadiobutton("radio1",gCommonDialogParam.GetString(14));
  setRadiobutton("radio2",gCommonDialogParam.GetString(15));
  
  //set radiogroup
  setRadiogroup(0);
	  
  //set dropdown list
  setDropdown(gCommonDialogParam.GetString(17));
  updatePasscardMenu(document.getElementById("dropdownMenulist0"));
  
  if (gCommonDialogParam.GetInt(3) == 0) // If no text fields
  {
    var dButton;
    var defaultButton = gCommonDialogParam.GetInt(5);
    switch (defaultButton) {
      case 3:
        dButton = document.documentElement.getButton("extra2");
        break;
      case 2:
        dButton = document.documentElement.getButton("extra1");
        break;
      case 1:
        dButton = document.documentElement.getButton("cancel");
        break;
      default:
      case 0:
        dButton = document.documentElement.getButton("accept");
        break;
    }
    // move the default attribute and focus from the accept button
    // to the one specified in the dialog params
    document.documentElement.getButton("accept").setAttribute("default",false);
    dButton.setAttribute("default", true);
    dButton.focus();
  }

  if (gCommonDialogParam.GetInt(6) != 0) // delay button enable
  {
    var delayInterval = 2000;
    try {
      var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Components.interfaces.nsIPrefBranch);
      delayInterval = prefs.getIntPref("security.dialog_enable_delay");
    } catch (e) {}

    document.documentElement.getButton("accept").disabled = true;
    document.documentElement.getButton("extra1").disabled = true;
    document.documentElement.getButton("extra2").disabled = true;

    setTimeout(commonDialogReenableButtons, delayInterval);
  }

  document.getElementById("protectFromFraud").checked = (gCommonDialogParam.GetInt(12) > 0);
  showFraudProtection();
  
  var checkboxObj = document.getElementById("snsenabled-checkbox");
  checkboxObj.checked = gCommonDialogParam.GetInt(13) != 0;
  if (checkboxObj.checked)
    OnSNSEnabled(checkboxObj);
  
  getAttention();
}

function getWebNavigation()
{
  
  try {
    return gBrowser.webNavigation;
  } catch (e) {
    return null;
  }
}

function updatePasscardMenu(menu) {
  
  var passwordManager =
    Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
  var enumerator = passwordManager.enumerator;
  var realm = gCommonDialogParam.GetString(18);
  var selectedPasscard = 0;
  
  document.getElementById("dropdown0Container").removeAttribute("collapsed");

  
  // keep track of number of passcards found for the specific realm
  var passcardCount = 0;

  var nextPassword;
  var host;
  var uniqueID;
  var passcard;
  var lastUsed;
  
  while (enumerator.hasMoreElements()) {
    try {
      nextPassword = enumerator.getNext();
    } catch(e) {}
    
    // get all info for the passcard
    nextPassword = nextPassword.QueryInterface(Components.interfaces.nsIPassword);
    host = nextPassword.host;
    uniqueID = nextPassword.uniqueID;
    passcard = nextPassword.passcard;
    lastUsed = nextPassword.lastUsed;
    
    if(realm == host) {
      debug("***Passcard -- passcard: " + passcard +
      		" uniqueID: " + uniqueID + " lastUsed: " + lastUsed + "\n");
      passcardCount++;
      
      // find the default passcard for realm
      if(eval(lastUsed))
        selectedPasscard = passcardCount-1; 
      
      menu.appendItem(passcard,uniqueID);
    }
  } // while
  
  menu.selectedIndex = selectedPasscard;
  
}

function commonDialogReenableButtons()
{
  document.documentElement.getButton("accept").disabled = false;
  document.documentElement.getButton("extra1").disabled = false;
  document.documentElement.getButton("extra2").disabled = false;
}

function initTextbox(aName, aLabelIndex, aValueIndex, aAlwaysLabel)
{
  unHideElementById(aName+"Container");

  var label = aLabelIndex < 0 ? "" : gCommonDialogParam.GetString(aLabelIndex);
  if (label || aAlwaysLabel && !label)
    setElementText(aName+"Label", label);
    
  var value = aValueIndex < 0 ? "" : gCommonDialogParam.GetString(aValueIndex);
  var textbox = document.getElementById(aName + "Textbox");
  textbox.setAttribute("value", value);
}

function setElementText(aElementID, aValue, aChildNodeFlag)
{
  var element = document.getElementById(aElementID);
  if (!aChildNodeFlag && element) {
    setLabelForNode(element, aValue, true);
  } else if (aChildNodeFlag && element) {
    element.appendChild(document.createTextNode(aValue));
  }
}



function setRadiobutton(aRBId, aRBMsg)
{
  if (aRBMsg) {
    
    document.getElementById(aRBId+"Container").removeAttribute("collapsed");
    var rbElement = document.getElementById(aRBId);
    setLabelForNode(rbElement, aRBMsg);
  }
}

function setDropdown(aDDMsg)
{  
  document.getElementById("dropdown1Container").removeAttribute("collapsed");
  var ddElement = document.getElementById("dropdownLabel");
  setLabelForNode(ddElement, aDDMsg,true);
  
  var stringBundle = document.getElementById("strings");
  
  var dropdownlist = document.getElementById("dropdownMenulist");
  dropdownlist.appendItem(stringBundle.getString("displayPromptText"),kPromptDisplay);
  dropdownlist.appendItem(stringBundle.getString("fillPasswordText"),kPromptAutoFill);
  dropdownlist.appendItem(stringBundle.getString("autologinText"),kPromptFillAndSubmit);
  dropdownlist.appendItem(stringBundle.getString("doNothingText"),kPromptDoNothing);
  
  dropdownlist.selectedIndex = gCommonDialogParam.GetInt(11);
  gCommonDialogParam.SetInt(11, dropdownlist.selectedItem.value);
}

function setRadiogroup(aRBIndex)
{
  if (aRBIndex) {   
    var rbGroupElement = document.getElementById("radiogroup");
    rbGroupElement.selectedIndex = aRBIndex;
  
    gCommonDialogParam.SetInt(7, 1);
    gCommonDialogParam.SetInt(8, 0);
    gCommonDialogParam.SetInt(9, 0);
    
    document.getElementById("nameLabel").disabled = true;
    document.getElementById("nameTextbox").disabled = true;
    document.getElementById("checkbox").disabled = true;
    document.getElementById("dropdownLabel").disabled = true;
    document.getElementById("dropdownMenulist").disabled = true;
    document.getElementById("snsenabled-checkbox").disabled = true;
    showFraudProtection(); 
    setMasterpassword();
  }
}

function unHideElementById(aElementID)
{
  var element = document.getElementById(aElementID);
  element.hidden = false;
}

function hideElementById(aElementID)
{
  var element = document.getElementById(aElementID)
  element.hidden = true;
}

function isVisible(aElementId)
{
  return document.getElementById(aElementId).hasAttribute("hidden");
}

function onDropdown1Click(aDropdownElement)
{
  gCommonDialogParam.SetInt(11, aDropdownElement.selectedItem.value);
  debug("option selected for 1 = " + gCommonDialogParam.GetInt(11)+'\n');
}

function onDropdown0Click(aDropdownElement)
{
  gCommonDialogParam.SetInt(10, aDropdownElement.selectedItem.value);
  debug("option selected for 0 = " + gCommonDialogParam.GetInt(10)+'\n');
}

function onRadio2Selected()
{
  document.getElementById("nameLabel").disabled = true;
  document.getElementById("nameTextbox").disabled = true;
  document.getElementById("checkbox").disabled = true;
  document.getElementById("dropdownLabel").disabled = true;
  document.getElementById("dropdownMenulist").disabled = true;
  document.getElementById("dropdownMenulist0").disabled = true;
  document.getElementById("protectFromFraud").disabled = true;
  document.getElementById("whatsthisLabel").disabled = true;
  document.getElementById("snsenabled-checkbox").disabled = true;
  showFraudProtection();
  gCommonDialogParam.SetInt(7, 0);
  gCommonDialogParam.SetInt(8, 0);
  gCommonDialogParam.SetInt(9, 1);
  debug("radio button 2 selected = " + gCommonDialogParam.GetInt(9)+'\n');
}

function onRadio0Selected()
{
  document.getElementById("nameLabel").disabled = true;
  document.getElementById("nameTextbox").disabled = true;
  document.getElementById("checkbox").disabled = true;
  document.getElementById("dropdownLabel").disabled = true;
  document.getElementById("dropdownMenulist").disabled = true;
  document.getElementById("snsenabled-checkbox").disabled = true;
  document.getElementById("dropdownMenulist0").removeAttribute("disabled");
  showFraudProtection(); 
  gCommonDialogParam.SetInt(7, 1);
  gCommonDialogParam.SetInt(8, 0);
  gCommonDialogParam.SetInt(9, 0);
  debug("radio button 0 selected = " + gCommonDialogParam.GetInt(7)+'\n');
}

function onRadio1Selected()
{
  document.getElementById("nameLabel").removeAttribute("disabled");
  document.getElementById("nameTextbox").removeAttribute("disabled");
  document.getElementById("checkbox").removeAttribute("disabled");
  document.getElementById("dropdownLabel").removeAttribute("disabled");
  document.getElementById("dropdownMenulist").removeAttribute("disabled");
  if (IsSNSEnabled())
    document.getElementById("snsenabled-checkbox").removeAttribute("disabled");
  showFraudProtection();
  document.getElementById("dropdownMenulist0").disabled = true;
  
  if (document.getElementById("snsenabled-checkbox").checked)
  {
    document.getElementById("checkbox").disabled = true;
  }

  showFraudProtection();
  checkFraudProtection();
  
  gCommonDialogParam.SetInt(7, 0);
  gCommonDialogParam.SetInt(8, 1);
  gCommonDialogParam.SetInt(9, 0);
  setMasterpassword();
  debug("radio button 1 selected = " + gCommonDialogParam.GetInt(8)+'\n');
}

function updatePromptOnAccept()
{
  debug('updatePromptOnAccept()\n');
  gCommonDialogParam.SetInt(0, 0); // say that ok was pressed

  var numTextBoxes = gCommonDialogParam.GetInt(3);
  var textboxIsPassword1 = gCommonDialogParam.GetInt(4) == 1;
  
  //set passcard name
  gCommonDialogParam.SetString(6, document.getElementById("nameTextbox").value);
  
  debug("value in name textbox = " + gCommonDialogParam.GetString(6)+'\n');
  
  gCommonDialogParam.SetInt(10, document.getElementById("dropdownMenulist0").selectedItem.value);
  gCommonDialogParam.SetInt(11, document.getElementById("dropdownMenulist").selectedItem.value);
  
  if (numTextBoxes >= 1) {
    var editField1;
    if (textboxIsPassword1)
      editField1 = document.getElementById("password1Textbox");
    else
      editField1 = document.getElementById("loginTextbox");
    gCommonDialogParam.SetString(6, editField1.value);
  }

  if (numTextBoxes == 2) {
    var editField2;
    if (textboxIsPassword1)
      // we had two password fields
      editField2 = document.getElementById("password2Textbox");
    else
      // we only had one password field (and one login field)
      editField2 = document.getElementById("password1Textbox");
    gCommonDialogParam.SetString(7, editField2.value);
  }
  return true;
}

function updatePromptOnExtra1()
{
  gCommonDialogParam.SetInt(0, 2);
  window.close();
}

function updatePromptOnExtra2()
{
  gCommonDialogParam.SetInt(0, 3);
  window.close();
}
