/*
	@function - returns enumeration of all files belonging to a directory
	@param - dir - the directory to which get all files
	@return - enumeration of files if successful ; null otherwise 
*/
function GetDirectoryFiles(dir)
{
	var entries = null;
	var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance();
	if (aFile instanceof Components.interfaces.nsILocalFile)
	{
		try {
			aFile.initWithPath(dir)
			if(aFile.isDirectory())
			{
				entries = aFile.directoryEntries;
			}
		}
		//if directory doesn't exist
		catch(e) {}
	}
	
	return entries;
}

 function getImageList(dir) {
 		
 		var folder = Components.classes["@mozilla.org/file/local;1"].createInstance();
		if (folder instanceof Components.interfaces.nsILocalFile) {
 		try {
			folder.initWithPath(dir);
			if(folder.isDirectory())
			{
				var entries = folder.directoryEntries;
			}
		}
		//if directory doesn't exist
		catch(e) {			
			return null;
		}
	}
		
	var list = new Array();
						
	while (entries.hasMoreElements()) {
	   var entry = entries.getNext();
	   entry.QueryInterface(Components.interfaces.nsILocalFile);
	   var fileName = entry.leafName;	           	           
	   var extension = fileName.substring(fileName.length-4);
	   
	   if (extension =='.png' ||
	   		 extension =='.gif' || 
	   		 extension =='.bmp' ||
	   		 extension =='.jpg' ||
	   		 extension =='.tif') {	           		 		
	           list[list.length] = entry.path;
	   }
	}
	return list;		 	
 } 


/*
	@function - getNextFile - returns the next NSIFile in the directory 
	@param - entries - list of files in directory
	@return - next file in directory ; null otherwise 
*/
function getNextFile(entries)
{
	var entry = null;
	if (entries.hasMoreElements())
	{
		entry = entries.getNext();
		entry.QueryInterface(Components.interfaces.nsIFile);
	}
	if (entry != null)
	{
		//ignore all non picture files	
		if (entry.path.toUpperCase().lastIndexOf(".png".toUpperCase()) ==-1 && entry.path.toUpperCase().lastIndexOf(".gif".toUpperCase()) ==-1 &&entry.path.toUpperCase().lastIndexOf(".bmp".toUpperCase()) ==-1 && entry.path.toUpperCase().lastIndexOf(".jpg".toUpperCase()) == -1 && entry.path.toUpperCase().lastIndexOf(".tif".toUpperCase()) == -1)
		{
			return getNextFile(entries);
		}
	}
	return entry;
}


/*
	@function - InsertImageIntoRowGrid - inserts image into the row  
	@param - row - reference to current row
	@param - pic - path of picture file
	@return - void
*/
function InsertImageIntoRowGrid(row, pic)
{
	var picture = document.createElement("profilePicture");
	var path = "file:///"+ pic;
	picture.setAttribute("src",path );
	picture.setAttribute("class", "viewListItem");	
	row.appendChild(picture);
	return picture;
}

function loadProfileImagesToElement(aElement) 
{					
	try {
		var directoryService = Components.classes["@mozilla.org/file/directory_service;1"]
		                                 .getService(Components.interfaces.nsIProperties);												
		debug(directoryService);
		var userProfile = directoryService.get("ProfD", Components.interfaces.nsIFile);					
		debug(userProfile);
		var entries = GetDirectoryFiles(userProfile.path+"\\DefaultPictures");
		debug(entries);								
		var entry = getNextFile(entries);
		while (entry != null ) {			  				  	 
			var picture = document.createElement("profilePicture");
			var path = "file:///"+ entry.path;
			picture.setAttribute("src",path );
			picture.setAttribute("class","viewListItem" );			  	
			aElement.appendChild(picture);  				  	 						 					  						 					 			  									 
			entry = getNextFile(entries);				 				 
		}		
	} catch (e) {dump(e.message);}
}
	

function checkForValidFilePath(fp, filepath)
{
	if (filepath.indexOf(fp) > -1) {
		return true;
	} else {
		return false;
	}
}


/*
	@function - isFileInApplicationDirectory - checks if file location belongs to application default picture location  
	@param - filepath - complete path  of the file in question
	@return - true if file is in correct location; otherwise false
*/
function isFileInApplicationDirectory(filepath)
{
	var result = false;
	var directoryService  =  Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
	var fp = directoryService.get("DefRt", Components.interfaces.nsIFile);		
	
	if (checkForValidFilePath(fp.path+"\\DefaultPictures", filepath))
	{
		result = true;
	}
	return result;
}


/*
	@function - isFileInProfileDirectory - checks if file location belongs to profile default picture location  
	@param - filepath - complete path  of the file in question
	@return - true if file is in correct location; otherwise false
*/
function isFileInProfileDirectory(filepath)
{
	var result = false;
	var	directoryService  =  Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);		
	var fp= directoryService.get("ProfD", Components.interfaces.nsIFile);
	if(	checkForValidFilePath(fp.path+"\\DefaultPictures", filepath))
	{
		result = true;
	}
	return result;
}


function copyFile(sourcefile,destdir)
{
	// get a component for the file to copy
	var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	if (!aFile) return false;
	
	// get a component for the directory to copy to
	var aDir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	if (!aDir) return false;
	
	var stripedString = sourcefile.substring((sourcefile.indexOf("file:///")+8),sourcefile.length);
	
	// next, assign URLs to the file components
	aFile.initWithPath(stripedString);
	
	aDir.initWithPath(destdir);
	
	var newName = profileUtils.getUniqueProfileName()+sourcefile.substring((sourcefile.lastIndexOf(".")),sourcefile.length);
	// finally, copy the file, without renaming it
	aFile.copyTo(aDir,newName);
	return("file:///"+destdir+ "\\"+newName);
}

function OpenPictureFilePicker()
{
	 var pic =""; 
	 const nsIFilePicker = Components.interfaces.nsIFilePicker;
   var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
   fp.init(window, "", nsIFilePicker.modeOpen);
   fp.appendFilters(nsIFilePicker.filterImages );
   if (fp.show() == nsIFilePicker.returnOK) 
   {
   	 pic = fp.file.path			  
  }
  return pic;
}