/* -*- Mode: C; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is Mozilla Communicator client code, released
 * March 31, 1998.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation. Portions created by Netscape are
 * Copyright (C) 1998-1999 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s):
 *   Ben Goodger (03/01/00)
 *   Seth Spitzer (28/10/99)
 *   Dan Veditz <dveditz@netscape.com>
 *   Benjamin Smedberg <bsmedberg@covad.net>
 */

const PromptService = "@mozilla.org/embedcomp/prompt-service;1";

var gDialogParams;
var gProfileManagerBundle;
var gBrandBundle;

var gPromptService;
var gDefaultProfileParent;
var gSelectedProfile;
var gBoxOtherProfilesContainer;
var gSelectorView;
var DEBUG = false;
var gDeckMain;
var gProfileLoginDisplay;
var gtxtLoginPassword;
var profileUtils;

const MODE_SHOW_PROFILE_SELECTOR = "MODE_SHOW_PROFILE_SELECTOR";
const MODE_SHOW_LOGIN_FIELDS = "MODE_SHOW_LOGIN_FIELDS";
const MODE_SHOW_LOGIN_ERROR = "MODE_SHOW_LOGIN_ERROR";
const MODE_SHOW_PROFILE_CREATION = "MODE_SHOW_PROFILE_CREATION";
const MODE_SHOW_PROFILE_SUCCESS = "MODE_SHOW_PROFILE_SUCCESS";
var gCurrentMode;

function debug(msg){
    
    if (msg && DEBUG) {
            dump('profileSelector.js : ' + msg + '\n')
    }
            
}



function startup()
{   
  try {
		profileUtils = new objProfileManager();
		profileUtils.initServices();
    profileUtils.refreshProfiles();
    var profileList = profileUtils.getProfiles();
    
    // BLT 211334: no displayName defined in 8.0.4		
	while (profileList.hasMoreElements()) {
		var profile = profileList.getNext().QueryInterface(Components.interfaces.nsIToolkitProfile);
		if(profile.displayName.length == 0) {
			profile.displayName = profile.name;
		}
	}
    
    gCurrentMode = MODE_SHOW_PROFILE_SELECTOR;
    gDialogParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);              
    gBrandBundle = document.getElementById("bundle_brand");      
    gProfileManagerBundle = document.getElementById("bundle_profileManager");
    gPromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
        gProfileLoginDisplay =document.getElementById("profileLoginDisplay");
    gProfileCreatedDisplay = document.getElementById("profileCreatedDisplay");
    gTxtCreateProfileDisplayName = document.getElementById("txtCreateProfileDisplayName");
    gTxtLoginPassword =document.getElementById("txtLoginPassword");             
    gDeckMain = document.getElementById("deckMain");  
    gSelectorView = document.getElementById("selectorView");                    
    gBoxOtherProfilesContainer =  document.getElementById("boxOtherProfilesContainer");         
    gSelectorView.addEventListener("richview-select", profileSelected, false);              
    gNewProfilebutton = document.getElementById("newProfilebutton");
    gNewProfileBtnSpacer = document.getElementById("newProfileBtnSpacer"); 
    loadProfileImagesToElement(document.getElementById("boxProfilePictures"));
    
    refreshProfileSelector();               
    setSelectedProfile();
    LoadImagesToXUL();
    debug('we are going to start');
    if(!profileUtils.getSecondTimeAround())
    {
    debug('its not the 2nd time');
        if(profileUtils.getDefaultProfile() && !profileUtils.didUserLogout())
    {
        debug('we have a default profile ' + profileUtils.getDefaultProfile());
        gSelectedProfile =  profileUtils.getProfileByName(profileUtils.getDefaultProfile());
                                
            if (isPasswordProtected(gSelectedProfile)){
                gCurrentMode = MODE_SHOW_LOGIN_FIELDS;
            doLayout();         
            } else {
                login();
                return;
        }
        
        gCurrentMode = MODE_SHOW_LOGIN_FIELDS;
        doLayout();
        document.getElementById("backButton").hidden= true;
    }
    	if(profileUtils.didUserLogout())
    	{
    		profileUtils.setUserLogout(false);
    		
  		}
    
  }     
		
  }
  catch(e) {
    window.close();
    throw (e);
  }
}

function refreshProfileSelector(){
        
        debug('refreshProfileSelector() start');
        while (gBoxOtherProfilesContainer.lastChild){
                    gBoxOtherProfilesContainer.removeChild(gBoxOtherProfilesContainer.lastChild);
        } 
        
                
        try {               
                
            var profileList = profileUtils.PROFILE_SVC.profiles;
            
                debug('building profile list - start');             
            // Build up the profile selection list              
                while (profileList.hasMoreElements()) {
                        var profile = profileList.getNext().QueryInterface(Components.interfaces.nsIToolkitProfile);
                        var item = document.getElementById("cloneThis").cloneNode(true);                                        
                        item.profile = profile;                                     
                    item.hidden = false;                    
                    item.setAttribute("class", "viewListItem");                 
                        gBoxOtherProfilesContainer.appendChild(item);
                        item.DoNotShowAdmin();
            }       
            
            //gProfiles.sort( function columnSort(a,b){
        //         return (a[0]<b[0])?-1:(a[0]>b[0])?1:0; })
                 
            debug('building profile list - end');           
    
    } catch (e) {
            debug('refreshProfileSelector() - failed'); 
            throw e;
    }
    
    debug('refreshProfileSelector() - end');
    
}
   
function loginClicked(){
    
    if (isPasswordProtected(gSelectedProfile)){     
        gCurrentMode = MODE_SHOW_LOGIN_FIELDS;
        doLayout();         
    } else {            
        login();
    }
}


function addAnotherClicked(){
    
    gCurrentMode =MODE_SHOW_PROFILE_CREATION; 
    doLayout();
    
}
function handleKeys (evt)
{                   
        debug('handleKeys() - mode = ' + gCurrentMode);     
        switch(gCurrentMode)
        {
            case MODE_SHOW_PROFILE_SELECTOR:    
                if (evt.keyCode == evt.DOM_VK_RETURN) profileSelected();        
                break;
            case MODE_SHOW_LOGIN_FIELDS:
                if (evt.keyCode == evt.DOM_VK_RETURN)   
                
                checkPassword();                                
                break;
            case MODE_SHOW_LOGIN_ERROR: 
                if (evt.keyCode == evt.DOM_VK_RETURN)   {
                    if (isPasswordProtected(gSelectedProfile)){     
                        gCurrentMode = MODE_SHOW_LOGIN_FIELDS;
                    doLayout();         
                    } else {            
                        login();
                }                                                           
                }
                break;
            case MODE_SHOW_PROFILE_CREATION:                
                if (isCreateDataValid()) {                  
                    if (evt.keyCode == evt.DOM_VK_RETURN) createProfile();
                document.getElementById('btnCreateProfile').disabled = false;                           
              } else {
                document.getElementById('btnCreateProfile').disabled  = true;
              }                                                                                           
                break;
            case MODE_SHOW_PROFILE_SUCCESS: 
                    if (evt.keyCode == evt.DOM_VK_RETURN) {
                        if (isPasswordProtected(gSelectedProfile)){     
                            gCurrentMode = MODE_SHOW_LOGIN_FIELDS;
                        doLayout();         
                        } else {            
                            login();
                    }
              }
                break;                      
            default:
            debug("case default\n");
                break;
        }       
}

function isPasswordProtected (profile){
    // requiresPasswordToLogin dependent on protectProfileWithPassword
    return gSelectedProfile.requiresPasswordToLogin &&
           gSelectedProfile.protectProfileWithPassword;
}

function profileSelected(){
    debug('profileSelected()'); 
    if (gSelectorView.selected.localName == "profile") {                        
        gSelectedProfile = gSelectorView.selected.profile;      
        if (isPasswordProtected(gSelectedProfile)){     
            gCurrentMode = MODE_SHOW_LOGIN_FIELDS;
        doLayout();         
        } else {            
            debug('no password required so logging in');    
            login();
    }
    }   
}

function checkPassword()
{   
        try {           
            
            var passed = profileUtils.authenticateUser(gSelectedProfile.name, gTxtLoginPassword.value);         
                        
            if(passed) 
            {               
                login();
            }
            else
            {       
                debug('Incorrect password entered');
            gCurrentMode = MODE_SHOW_LOGIN_ERROR;
            doLayout();             
            }
        } catch (e) {debug('checkPassword() - failed' + e.message); }
}

function showLoginFields(showErrorState){
    document.getElementById("boxPasswordEntry").hidden = showErrorState;
    document.getElementById("loginButton").disabled = showErrorState;   
    document.getElementById("boxIncorrectPassword").hidden = !showErrorState;       
    gTxtLoginPassword.value = "";   
}

function setSelectedProfile(){
    debug('setSelectedProfile()');           
    gSelectorView.removeEventListener("richview-select", profileSelected, false);
    try {
        // Get a reference to all the profile selector items
        var selectorItems = document.getElementsByAttribute('class', 'viewListItem');   
        if (gSelectedProfile){      
            for (var i = 0; i < selectorItems.length; ++i) {            
                if (selectorItems[i].profile === gSelectedProfile) {
                    debug('about to set selected property');        
                    gSelectorView.selected = selectorItems[i];                                                      
                }       
            }
        } else if (selectorItems.length >= 0) {         
            gSelectorView.selected = selectorItems[0];
        }       
  
    } catch (e) {
        debug('setSelectedProfile - failed -' + e.message);
    }
    gSelectorView.addEventListener("richview-select", profileSelected, false); 
    if (profileUtils.getShowProfileCreationButton() == true) {
        gNewProfilebutton.hidden = false;
        gNewProfileBtnSpacer.hidden = false;
    } else {
        gNewProfilebutton.hidden = true;
        gNewProfileBtnSpacer.hidden = true;
    }
        
}

function updateOKBtn()
{
    var okBtn = document.getElementById("loginButton");
    if (document.getElementById("txtLoginPassword").textLength == 0) {
        okBtn.setAttribute("disabled","true");
        okBtn.disabled=true;
    } else {
        okBtn.disabled=false;
        if (okBtn.hasAttribute("disabled")) okBtn.removeAttribute("disabled");
    }
}


function login()
{
    debug("login() - start");
  var appName = gBrandBundle.getString("brandShortName");
    
  if (!gSelectedProfile) {
    var pleaseSelectTitle = gProfileManagerBundle.getString("pleaseSelectTitle");
    var pleaseSelect =
      gProfileManagerBundle.getFormattedString("pleaseSelect", [appName]);
    gPromptService.alert(window, pleaseSelectTitle, pleaseSelect);

    return false;
  }

  var profileLock;

  try {
    profileLock = gSelectedProfile.lock();
  }
  catch (e) {
    var lockedTitle = gProfileManagerBundle.getString("profileLockedTitle");
    var locked =
      gProfileManagerBundle.getFormattedString("profileLocked", [appName, gSelectedProfile.name]);
    gPromptService.alert(window, lockedTitle, locked);

    return false;
  }
  gDialogParams.objects.insertElementAt(profileLock.nsIProfileLock, 0, false);

  //var autoSelectLastProfile = document.getElementById("autoSelectLastProfile");
  //gProfileService.startWithLastProfile = autoSelectLastProfile.checked;
  profileUtils.PROFILE_SVC.selectedProfileName = gSelectedProfile.name;
  //profileUtils.setLoggedInProfile(gSelectedProfile);
 
  //gProfileService.startOffline = document.getElementById("offlineState").checked;

  gDialogParams.SetInt(0, 1);
  window.close();
  profileUtils.updateZipCodeFromInstall(gSelectedProfile);
	profileUtils.getInstalledZipCode();
    debug("login() - end");
  return true;
}

function doLayout()
{       
    debug("doLayout() gCurrentMode = " + gCurrentMode);
    gProfileCreatedDisplay.profile = gSelectedProfile; //profile binding displayed for the successful create
    gProfileLoginDisplay.profile = gSelectedProfile;   //profile binding displayed for the login
    switch(gCurrentMode)
    {
        case MODE_SHOW_PROFILE_SELECTOR:            
            gDeckMain.selectedIndex = 0;                
            //setSelectedProfile();
            break;
        case MODE_SHOW_LOGIN_FIELDS:            
            gDeckMain.selectedIndex = 1;            
            //setSelectedProfile();
            document.getElementById("loginButton").disabled=false;
            showLoginFields(false);                     
            gTxtLoginPassword.focus();
            updateOKBtn();
            break;
        case MODE_SHOW_LOGIN_ERROR:
            gDeckMain.selectedIndex = 1;
            showLoginFields(true);  
            document.getElementById("loginButton").disabled=true;
            document.getElementById("okButton").focus();
            break;
        case MODE_SHOW_PROFILE_CREATION:
            gDeckMain.selectedIndex = 2;                
            gTxtCreateProfileDisplayName.focus();
            gTxtCreateProfileDisplayName.value = "";
            document.getElementById('btnCreateProfile').disabled  = true;
            document.getElementById("cbCreateProfileUsePassword").removeAttribute("checked");
            document.getElementById("txtCreateProfilePassword").value = "";
            document.getElementById("txtCreateProfilePasswordConfirm").value = "";
            document.getElementById("txtCreateProfileZipcode").value = profileUtils.getInstalledZipCode();
            
            //MERC - TO
            //BLT 195672
            //Give profiles default picture
            var pics = document.getElementById("boxProfilePictures");
            if(pics && pics.hasChildNodes()) {
                document.getElementById('picSelectorView').selected = pics.firstChild;
//              dump("\n\nHas Children: " + pics.firstChild.localName + "\n\n");
            }
            else {
                document.getElementById('picSelectorView').selected = "";
//              dump("\n\nNo Children: " + pics + "\n\n");
            }
                

            // This checks to see if we want all NEW acounts to require a password
            if (profileUtils.getAllProfilesNeedPassword() == true) {
                // show mandatory password fields
                document.getElementById("boxPasswordFields").hidden = false;                
                document.getElementById("cbCreateProfileUsePassword").checked = true;
                document.getElementById("cbCreateProfileUsePassword").hidden = true;
            } else {
                // show the optional password textbox   
                document.getElementById("boxPasswordFields").hidden = true;                         
            }
            break;
        case MODE_SHOW_PROFILE_SUCCESS:
        gDeckMain.selectedIndex = 3;            
            break;                      
        default:        
            break;
    }           
}


 function LoadImagesToXUL() 
    {
            
            var directoryService  =  Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
            var userProfile = directoryService.get("DefRt", Components.interfaces.nsIFile);     
            
            var entries = GetDirectoryFiles(userProfile.path+"\\DefaultPictures");
        
            var xulGrid = document.getElementById('boxProfilePictures');
//          var i = 0;
//          var row = document.createElement("hbox");
//        row.setAttribute("flex","1");
          if(entries) {
                    var entry = getNextFile(entries);
                    while(entry != null )
                      {
                        
                        
                        InsertImageIntoRowGrid(xulGrid, entry.path);
                        
                         
                         entry = getNextFile(entries);
                         
                         
                        }   
//              xulGrid.appendChild(row);
            }
    
    }


function toggleUsePassword()
{   
    var checkState = document.getElementById("cbCreateProfileUsePassword").getAttribute("checked");
    
    if(checkState){     
        document.getElementById("boxPasswordFields").hidden = false;    
        document.getElementById("txtCreateProfilePassword").focus();
    }else{  
        document.getElementById("boxPasswordFields").hidden = true;         
    }
            
    if(isCreateDataValid()) {
        document.getElementById('btnCreateProfile').disabled  = false;
    }else{
        document.getElementById('btnCreateProfile').disabled  = true;
    }       
}

function closeWindow()
{
    	window.close();
   
   //commented  logic out in case its required later	
 /*    if(!this.profileUtils.getSecondTimeAround() || this.profileUtils.getProfilesCount() >1 )
     { 
     			  window.close();
     }else
        {
        	
            var profileContainer = profileUtils.getProfiles();
            gSelectedProfile = profileContainer.getNext().QueryInterface(Components.interfaces.nsIToolkitProfile);
            if(gSelectedProfile.password == "")
            {
                login();
            }else
            {
                    window.close();
            }
    }
 */
}
        
function isCreateDataValid(){
            
    if (this.profileUtils.trim(gTxtCreateProfileDisplayName.value) == "") {
        return false;
    }
        
    if (document.getElementById("cbCreateProfileUsePassword").getAttribute('checked')) {        
        debug('password checked!');
        if (!document.getElementById("txtCreateProfilePassword").value){
            debug('isCreateDataValid() - invalid password');
            return false;
        }
        if (document.getElementById("txtCreateProfilePassword").value != document.getElementById("txtCreateProfilePasswordConfirm").value){
            debug('isCreateDataValid() - passwords do no match');
            return false;
        }                                                       
    }       
    
    var zipCode = document.getElementById("txtCreateProfileZipcode");
    if (zipCode.value != '' && !zipCode.isValid){
        debug('isCreateDataValid() - invalid zip code');
        return false;
    }
    
    if (profileUtils.isDisplayNameExist(document.getElementById("txtCreateProfileDisplayName").value)){
            return false;           
    }           
    
    debug('isCreateDataValid() - valid data');
    return true;                            
}       
            
function createProfile()
{
    debug('createProfile() - start');
    
    if (isCreateDataValid()) {
    
        debug('createProfile() - valid data - proceeding to create profile');
        
        try{
            var profile = profileUtils.createProfile(true);
            var usePassword = document.getElementById("cbCreateProfileUsePassword").checked;
            var password = document.getElementById("txtCreateProfilePassword").value;               
            profile.displayName = gTxtCreateProfileDisplayName.value;   
            
            if (usePassword &&
                    password && 
                    password !="" && 
                    password.length > 0) {
                        debug('setting profile password');
                        profile.setProfilePassword(password);   
                        profile.protectProfileWithPassword = true;
                        profile.requiresPasswordToLogin = true;
            }
            profile.isAdmin = false;
            profile.zipCode = document.getElementById("txtCreateProfileZipcode").value;
            var picViewSelector = document.getElementById('picSelectorView');
            if(picViewSelector.selected)
            {
        
                profile.picPath =   picViewSelector.selected.getAttribute('src');
                if(!isFileInApplicationDirectory(profile.picPath))
                    {
                        profile.picPath = copyFile(profile.picPath,(profile.rootDir.path +"\\DefaultPictures"));    
                    }
            }
            
            gSelectedProfile = profile; 
            refreshProfileSelector();
            setSelectedProfile();
                            
        } catch(e)
        {
            debug("createProfile() - failed - " + e.message );
            return;
        }
                                    
        // TODO: gSelectedProfile = profile;
        profileUtils.setDefaultProfile("");
				profileUtils.setStartWithLastProfile(false);
        gCurrentMode = MODE_SHOW_PROFILE_SUCCESS;
        doLayout();     
    }   
    debug('createProfile() - end');
} 


function OpenFilePicker()
{
    var picFile = OpenPictureFilePicker();
    
        if(picFile.length > 0)
        {
                var xulGrid = document.getElementById('boxProfilePictures');
                
                //var row = null;
              if(xulGrid.hasChildNodes()) 
              {
                        //var row = xulGrid.lastChild;
                        var picture = InsertImageIntoRowGrid(xulGrid,picFile );
                        var picViewSelector = document.getElementById('picSelectorView');
                        picViewSelector.selected = picture;
                    
              }
              
    }
    
}
       







