/* PROFILE MANAGER */

	function objProfileManager() {		
	
	this.PROFILE_SVC = null;																	
	this.DIR_SVC = null;																						
	this.RDF_SVC = null;				
	this.profileListLocal = null;
	this.DEBUG = false;				
}

	objProfileManager.prototype = {
		
		debug : function(msg) {
				if (this.DEBUG)
					dump('profileUtils.js: objProfileManager: '+msg+'\n');
		},
		
		initServices : function() {			
			this.debug('initServices()');		
			this.PROFILE_SVC = Components.classes["@mozilla.org/toolkit/profile-service;1"]
															.getService(Components.interfaces.nsIToolkitProfileService);																
																	
			this.DIR_SVC = Components.classes["@mozilla.org/file/directory_service;1"]
															.getService(Components.interfaces.nsIProperties);																	
																								
			this.RDF_SVC       = Components.classes["@mozilla.org/rdf/rdf-service;1"]
															.getService(Components.interfaces.nsIRDFService);																																																																																									
		},
				
		setDefaultProfile: function(name)
		{	
			this.PROFILE_SVC.defaultProfileName = name;
		},
		getProfileByName:function(aName)
		{
			return  this.PROFILE_SVC.getProfileByName(aName);		
		},
		
		setUserLogout:function(avalue)
		{
			this.PROFILE_SVC.isLogout = avalue;		
		},
		
		didUserLogout:function()
		{
			return  this.PROFILE_SVC.isLogout;		
		},
		removeProfile: function(profile)
		{				
			profile.remove(false);			
			this.profileListLocal[profile.name] = null;									
		},
		
		updateZipCodeFromInstall: function(profile)
		{
			try 
				{
				
				if(profile.zipCode == "")
				{
							 
						var prefService = Components.classes["@mozilla.org/preferences-service;1"]
			                       .getService(Components.interfaces.nsIPrefService);
			      var thesePrefs = prefService.getBranch("spui.");
						var currentZipcode = thesePrefs.getCharPref("weather.zipcode");
						
						profile.zipCode = currentZipcode;
						debug("profile " + profile.zipCode + " pref " + currentZipcode);
						this.flush(); 
				}
		}catch(e)
			{
				
			}
		},
		
		getInstalledZipCode:function()
		{
			var currentZipcode = "";
			try 
				{
				
							 
						var prefService = Components.classes["@mozilla.org/preferences-service;1"]
			                       .getService(Components.interfaces.nsIPrefService);
			      var thesePrefs = prefService.getBranch("spui.");
						currentZipcode = thesePrefs.getCharPref("weather.zipcode");
						debug(" pref " + currentZipcode);
			}catch(e)
			{
					debug("no zipCOde!!!!!!");
			}
			return currentZipcode;
		},
		/*getDefaultPic: function()
		{
			var used = new Array();
			var i = 0;
			var plist = this.getProfiles();
			while(plist.hasMoreElements())			
			{
					var profile = plist.getNext().QueryInterface(Components.interfaces.nsIToolkitProfile);
					if(profile.picPath)
					{
						if (used.indexOf(profile.picPath) > -1) continue //on ignore list no go; 		
						
						used.push(profile.picPath);								
					}
						
			}
			return used;
		}, */
					
		// Build up a list of all display names 
		// used by existing profiles
		getDisplayNameList : function (){
			this.debug("getDisplayNameList()");
			
			try {
				var profiles = this.getProfiles();
				var profileList = null;
				
				while(profiles.hasMoreElements())
				{
					if (!profileList) profileList = new Array();
					var profile = profiles.getNext().QueryInterface(Components.interfaces.nsIToolkitProfile);
					profileList.push(profile.displayName);
				}			
				
				return profileList;						
			} catch (e) {
				this.debug("getDisplayNameList() - failed");
				throw e;
			}	
			
		},
				
		// Get a default display name for a profile
		// using 'default' as a start. If default is
		// used then concatenate an offset to 'default'
		// until we find a combination that hasn't been used
		getDefaultDisplayName : function (){
			this.debug("getDefaultDisplayName()");									
			try {
				var displayNameList = this.getDisplayNameList();						
				var offSet = 1 ;						
				if (this.indexOfString(displayNameList,'default') == -1) {																
					return 'default';
				} else {				
					var result = 'default' + offSet;
					while(this.indexOfString(displayNameList,result) > -1){										
						offSet ++;
						result = 'default' + offSet;											
					}				 				
				}			
				return result;	
						
			} catch (e) {
				this.debug("getDefaultDisplayName() - failed");
				throw e;
			}	
		},
		/* trim leading and trailing whitespace from a string */
		trim: function(str)
		 {
		   if (str) {
		      str=str.replace(/^\s*/,"");
		      str=str.replace(/\s*$/,"");
    }
	     return str;
	 }, 
	 
		getAdminProfiles: function()
		{
			var adminArray = new Array();
			var i = 0;
			var plist = this.getProfiles();
			while(plist.hasMoreElements())
			{
					var profile = plist.getNext().QueryInterface(Components.interfaces.nsIToolkitProfile);
					if(profile.isAdmin)
					{
						adminArray[i] = profile;
						i ++;
					}
						
			}
			return adminArray;
		},
					
		getDefaultProfile: function()
		{
			return this.PROFILE_SVC.defaultProfileName;
		},
		setStartWithLastProfile: function(value)
		{
			this.PROFILE_SVC.startWithLastProfile = value;
		},
		setAllowNewProfileCreation: function(value)
		{
	
			this.PROFILE_SVC.allowNonAdminProfileCreation = value;
		},

		setSecondTimeAround: function(value)
		{
	
			this.PROFILE_SVC.secondTimeRun = value;
		},
		getSecondTimeAround: function()
		{
	
			return this.PROFILE_SVC.secondTimeRun;
		},				
		
		getAllowNewProfileCreation: function()
		{
			return this.PROFILE_SVC.allowNonAdminProfileCreation;
		},

		setAllProfilesNeedPassword: function(value)
		{
	
			this.PROFILE_SVC.allProfilesNeedPassword = value;
		},
		
		
		getAllProfilesNeedPassword: function()
		{
			return this.PROFILE_SVC.allProfilesNeedPassword;
		},
	
		setAllProfilesNeedPasswordToLogin: function(value)
		{

		this.PROFILE_SVC.allProfilesNeedPasswordToLogin = value;
		},
		
		
		getAllProfilesNeedPasswordToLogin: function()
		{
			return this.PROFILE_SVC.allProfilesNeedPasswordToLogin;
		},
										
		refreshProfiles: function() {			
			try{
				
				this.PROFILE_SVC.refreshService();	
				this.profileListLocal = new Array();
				this.profileList = this.PROFILE_SVC.profiles;			
				var resetSharedData = true;
				while (this.profileList.hasMoreElements()) {				  
				  var profile = this.profileList.getNext().QueryInterface(Components.interfaces.nsIToolkitProfile);				  				 
				  this.profileListLocal[profile.name] = new objLocalProfile(profile);					  				  				  
				  if (resetSharedData) {
				  		this.profileListLocal[profile.name].resetSharedData();
				  		resetSharedData = false;
				  }
				 }
			}catch(e)
			{
				this.debug("refreshProfiles failed" + e.message );
				throw e;
			}			
		},
	
		getProfiles: function() {
		
			try{
				return this.PROFILE_SVC.profiles;	
			}catch(e)
			{
				this.debug("getProfiles failed" + e.message );
				throw e;
			}			
		},
	
		getProfilesCount: function() {
		
			
				return this.PROFILE_SVC.profileCount;	
						
		},						
		getUniqueProfileName : function() {
			
			const kSaltTable = [
		  'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
		  'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
		  '1', '2', '3', '4', '5', '6', '7', '8', '9', '0' ];
	
			var kSaltString = "";
	
			for (var i = 0; i < 8; ++i) {
	  		kSaltString += kSaltTable[Math.floor(Math.random() * kSaltTable.length)];
			}
					
			return kSaltString;		
		},
		
		//attribute boolean ShowProfileCreationButton;
		setShowProfileCreationButton : function(value) {
			try {
				this.PROFILE_SVC.showProfileCreationButton = value;
			} catch(e) {
				this.debug("setShowProfileCreationButton failed" + e.message);
				throw e;
			}
		},

		//attribute boolean ShowProfileCreationButton;
		getShowProfileCreationButton : function() {
			try {
				return this.PROFILE_SVC.showProfileCreationButton;
			} catch(e) {
				this.debug("getShowProfileCreationButton failed" + e.message);
				throw e;
			}
		},
		
		setLoggedInProfile : function(aProfile) { 
		
			try{
				this.PROFILE_SVC.selectedProfile = aProfile;	
			}catch(e)
			{
				this.debug("setLoggedInProfile failed" + e.message );
				throw e;
			}					
						
		},
		
		getLoggedInProfile : function() { 
		
			try{
				if (this.PROFILE_SVC.selectedProfileName != "")
					return this.PROFILE_SVC.getProfileByName(this.PROFILE_SVC.selectedProfileName);	
				else
					return this.PROFILE_SVC.selectedProfile;
			}catch(e)
			{
				this.debug("getLoggedInProfile failed" + e.message );
				throw e;
			}					
						
		},
		
		authenticateUser : function(name, password) { 
			
			try{
					return this.PROFILE_SVC.authenticateUser(name, password)
					
			}catch(e)
			{
				this.debug("authenticateUser failed" + e.message );
				throw e;
			}						
				this.debug("authenticateUser succeeded");						
		},
		
	isDisplayNameConflict: function(aTestDisplayName){
		this.debug("isDisplayNameUnique(" + aTestDisplayName + ")");						
		var list = this.getListOfProfileDisplayNames();
		this.debug("list.length =" + list);								
		return this.getStringCount(list,aTestDisplayName) > 1; 					
	},	
		
	isDisplayNameExist : function(aTestDisplayName){
		
		this.debug("isDisplayNameExist(" + aTestDisplayName + ")");						
		var list = this.getListOfProfileDisplayNames();
		this.debug("list.length =" + list);								
		return this.indexOfString(list,aTestDisplayName) != -1; 		
		
	},
	
	// How many times does a given string appear in an array
	getStringCount : function(targetArray, key) {
		this.debug("getStringCount()");	
		var result = 0;				
		for (index in targetArray){
			this.debug(targetArray[index].toUpperCase() + ' =>   ' + key.toUpperCase());
			if (targetArray[index].toUpperCase() == key.toUpperCase()){
				result ++;
			}
		}		
		this.debug("getStringCount() = " + result);	
		return result;				
	},
	
	
	indexOfString : function(targetArray, key) {		
		this.debug("indexOfString()");					
		for (index in targetArray){
			this.debug(targetArray[index].toUpperCase() + ' =>   ' + key.toUpperCase());
			if (targetArray[index].toUpperCase() == key.toUpperCase()){
				return index;
			}
		}
		return -1; 
		   		
	},		
	
	getListOfProfileDisplayNames: function (){
			
			var result = new Array();						
			var profiles = this.PROFILE_SVC.profiles;
			while(profiles.hasMoreElements())
			{
					var profile = profiles.getNext().QueryInterface(Components.interfaces.nsIToolkitProfile);										
					result.push(profile.displayName);											
			}
			return result;			
		},
			
		createProfile : function(isFromProfileSelector) {
			
			this.debug('createProfile() - start');
			
			var defaultProfileDir;
			var result;
			var uniqueName = this.getUniqueProfileName();
			
				try
				{
					// Create the profile directory
					defaultProfileDir = this.DIR_SVC.get("DefProfRt", Components.interfaces.nsIFile);				
					defaultProfileDir = defaultProfileDir.clone();
					defaultProfileDir.append(uniqueName);				
															
					this.debug("createProfile() - target directory created: " + defaultProfileDir.path);
					
				} catch(e)
				{
					this.debug("createProfile() - failed to create target directory - " + e.message );
					throw e;
				}											
					
				try
				{				
					if (isFromProfileSelector) {
						result = this.PROFILE_SVC.createProfile(defaultProfileDir, uniqueName);					
					} else {
						result = this.PROFILE_SVC.createProfileInternal(defaultProfileDir, uniqueName);					
					}
					
					// Note: the default blocking mode is set in nsToolkitProfile.CreateProfile																				
					this.profileListLocal[result.name] = new objLocalProfile(result);							
					this.profileListLocal[result.name].createdThisSession = true;					
					result.displayName = this.getDefaultDisplayName();					
														
					this.debug("createProfile() - profile created successfully: " + result.name);						
									
				} catch(e)
				{
					this.debug("createProfile() - ProfileService failed to create profile - " + e.message);
					throw e;
				}							
			
				this.debug('createProfile() - end');
				return result;
		},		
	
		flush : function()
		{			
			this.PROFILE_SVC.flush();
			for (var name in this.profileListLocal){ 				
				if (this.profileListLocal[name]) {					
					this.profileListLocal[name].flush(); 														
					//show_rdf_ds(this.profileListLocal[name].getParentalControlLists());
				}
			}			
		}
};


function objLocalProfile(profile) {	    		
		this.profile = profile;			
		this.PARENTAL_CTRL_SVC = Components.classes["@mozilla.org/browser/parentalcontrols-service;1"]
									.createInstance(Components.interfaces.nsIParentalControlsAdmin);																						
		this.initializeParentalControlData();		
		this.createdThisSession = false;	
		this.lists = null;		
		this.DEBUG = false;	
}		

objLocalProfile.prototype = {	

			
	debug : function(msg) {
		if (this.DEBUG)				
			dump('profileUtils.js: objLocalProfile [' + this.profile.name + ']:'+msg+'\n');
	},
		
	setParentalControlMode: function(mode) {
		this.debug('setParentalControlMode(' + mode + ')');
		try {			
			this.PARENTAL_CTRL_SVC.mode = mode;	
		} catch(e) {
			this.debug("setParentalControlMode failed" + e.message );
			throw e;
		}			
		this.debug('setParentalControlMode end');		
	},
	
	resetSharedData: function() {
		this.debug('resetSharedData()');
		try {			
			this.PARENTAL_CTRL_SVC.resetSharedData();										  				  				  			
		} catch(e) {
			this.debug("resetSharedData() failed" + e.message );
			throw e;
		}			
		this.debug('resetSharedData() end');		
	},
				
	initializeParentalControlData: function() {
		this.debug("initializeParentalControlData()");
		
		try {			
			
			if ((this.profile.blockingMode != Components.interfaces.nsIParentalControlsService.PC_MODE_ACCEPT) &&
					(this.profile.blockingMode != Components.interfaces.nsIParentalControlsService.PC_MODE_BLOCK)) {
												 
						this.PARENTAL_CTRL_SVC.loadProfile(this.profile.rootDir.path,						
																							Components.interfaces.nsIParentalControlsService.PC_MODE_BLOCK);							
			} else {						
					
					this.PARENTAL_CTRL_SVC.loadProfile(this.profile.rootDir.path,this.profile.blockingMode);	
			}
			
			this.debug("PARENTAL_CTRL_SVC.loadProfile(" + this.profile.rootDir.path + "," + this.profile.blockingMode + ")");
													
		} catch(e) {
			this.debug("initializeParentalControlData failed" + e.message );
			throw e;
		}			
	},		
				
	getParentalControlLists: function(doRequery) {
		this.debug('getParentalControlLists');
		try {		
			if (doRequery || this.lists == null) {
				var result = this.PARENTAL_CTRL_SVC.lists;
			} else {
				var result = this.lists		
			}
			//show_rdf_ds(result); 
			return result;			
			
		} catch(e) {
			this.debug("getParentalControlLists failed" + e.message );
			throw e;
		}			
		this.debug('getParentalControlLists end');				
	},
				
	addSiteToProfile: function(uri, isAllowed) {
		this.debug('addSiteToProfile site:' + uri + ' allowed: ' + isAllowed);
		try {
			this.PARENTAL_CTRL_SVC.addSite(uri, false,isAllowed);	
		} catch(e) {
			this.debug("addSiteToProfile failed" + e.message );
			throw e;
		}			
		this.debug('addSiteToProfile end');		
	},
	
	addSiteToGlobal: function(uri, isAllowed) {
		this.debug('addSiteToGlobal site:' + uri + ' allowed: ' + isAllowed);
		try {
			this.PARENTAL_CTRL_SVC.addSite(uri, true, isAllowed);	
		} catch(e) {
			this.debug("addSiteToGlobal failed" + e.message );
			throw e;
		}			
	},
	
	removeSiteFromProfile: function(uri, isAllowed) {
		this.debug('removeSiteFromProfile site:' + uri + ' allowed: ' + isAllowed);
		try {
			this.PARENTAL_CTRL_SVC.removeSite(uri, false,isAllowed);	
		} catch(e) {
			this.debug("removeSiteFromProfile failed" + e.message );
			throw e;
		}					
	},
	
	removeSiteFromGlobal: function(uri, isAllowed) {
		this.debug('removeSiteFromGlobal site:' + uri + ' allowed: ' + isAllowed);
		try {
			this.PARENTAL_CTRL_SVC.removeSite(uri, true, isAllowed);	
		} catch(e) {
			this.debug("removeSiteFromGlobal failed" + e.message );
			throw e;
		}			
	},
	
	addListToProfile: function(providerID, isAllowed) {
		this.debug('addListToProfile providerID:' + providerID + ' allowed: ' + isAllowed);
		try {
			this.PARENTAL_CTRL_SVC.addList(providerID, false,isAllowed);	
		} catch(e) {
			this.debug("addListToProfile failed" + e.message );
			throw e;
		}					
	},
	
	addListToGlobal: function(providerID, isAllowed) {
		this.debug('addListToGlobal providerID:' + providerID + ' allowed: ' + isAllowed);
		try {
			this.PARENTAL_CTRL_SVC.addList(providerID, true , isAllowed);	
		} catch(e) {
			this.debug("addListToGlobal failed" + e.message );
			throw e;
		}			
	},
	
	removeListFromProfile: function(providerID, isAllowed) {
		this.debug('removeListFromProfile providerID:' + providerID + ' allowed: ' + isAllowed);
		try {
			this.PARENTAL_CTRL_SVC.removeList(providerID, false , isAllowed);	
		} catch(e) {
			this.debug("removeListFromProfile failed" + e.message );
			throw e;
		}					
	},
	
	removeListFromGlobal: function(providerID, isAllowed) {
		this.debug('removeListFromGlobal providerID:' + providerID + ' allowed: ' + isAllowed);
		try {
			this.PARENTAL_CTRL_SVC.removeList(providerID, true , isAllowed);	
		} catch(e) {
			this.debug("removeListFromGlobal failed" + e.message );
			throw e;
		}			
	},		
	canActOnSite: function(uri, isAdd, isGlobal, isAllowed) {
		this.debug('canActOnSite(' + uri + ',' + isAdd + ',' + isGlobal + ',' + isAllowed + ')');
		var result = false;
		try {			
			result = this.PARENTAL_CTRL_SVC.canActOnSite(uri, isAdd, isGlobal, isAllowed);	
		} catch(e) {			
			this.debug("canActOnSite failed" + e.message );
			throw e;
		}					
		return result;
	},	
	
	canActOnList: function(providerID, isAdd, isGlobal, isAllowed) {
		this.debug('canActOnList(' + providerID + ',' + isAdd + ',' + isGlobal + ',' + isAllowed + ')');
		var result = false;
		try {
			result = this.PARENTAL_CTRL_SVC.canActOnList(providerID, isAdd, isGlobal, isAllowed);	
		} catch(e) {			
			this.debug("canActOnList failed" + e.message );
			throw e;
		}					
		return result;
	},	
	
	flush: function() {
		this.debug('flush()');
		try {
			this.PARENTAL_CTRL_SVC.saveChanges();	
		} catch(e) {
			this.debug("save failed" + e.message );
			throw e;
		}			
	}             																				
}; 

function show_rdf_ds(ds) {    
		                                                    
    this.debug('============= show_rdf_ds START =================');            
                                                                                
    var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"]       
                               .getService(Components.interfaces.nsIRDFService);
                                                                                
    var t="";                                                                   
                                                                                
    var all_res=ds.GetAllResources();                                           
                                                                                
    for (var r=0; all_res.hasMoreElements(); r++)                               
    {                                                                                                                                                           
        //if(t.length>5000) break;  // comment out for unlimited output                                                                                         
        var res=all_res.getNext();                                                                                                                              
        // res is a resource                                                                                                                                    
        if (res instanceof Components.interfaces.nsIRDFResource)                
        {                                                                                                                                                       
          var tr=r + " R: "+res.Value+"\n";                                                                                                                     
          var ps= ds.ArcLabelsOut(res);                                                                                                                         
          while (ps.hasMoreElements())                                          
          {                                                                                                                                                     
            var predicate = ps.getNext();                                                                                                                       
            // predicate is a resource                                                                                                                          
            if (predicate instanceof Components.interfaces.nsIRDFResource)      
            {                                                                                                                                                   
              tr+="  -R:  "+predicate.Value+"\n";                                                                                                               
              var ts= ds.GetTargets(res, predicate, true);                                                                                                      
              while (ts.hasMoreElements())                                      
              {                                                                                                                                                 
                var target = ts.getNext();                                                                                                                      
                // target is either a resource, a literal or a typed-literal                                                                                    
                if (target instanceof Components.interfaces.nsIRDFResource)                                                                                     
                  tr+="   >R: "+target.Value+"\n";                                                                                                              
                else                                                                                                                                            
                if (target instanceof Components.interfaces.nsIRDFLiteral)                                                                                      
                  tr+="    >L: "+target.Value+"\n";                                                                                                             
                else                                                                                                                                            
                if (target instanceof Components.interfaces.nsIRDFBlob)                                                                                         
                  tr+="    >BLOB length:"+target.length+"\n";                                                                                                   
                else                                                                                                                                            
                if (target instanceof Components.interfaces.nsIRDFInt)                                                                                          
                  tr+="    >INT:"+target.Value+"\n";                                                                                                            
                else                                                                                                                                            
                if (target instanceof Components.interfaces.nsIRDFDate)         
                                                                                
                  tr+="    >DATE: "+target.Value+"\n";                          
                                                                                
                else                                                                                                                                            
                if (target instanceof Components.interfaces.nsIRDFNode)                                                                                         
                  tr+="    >Node \n";                                                                                                                           
                else                                                                                                                                            
                  tr+="    >Unknown\n";                                                                                                                         
              }                                                                                                                                                 
            } // end predicate-res                                                                                                                              
         } // end ps                                                            
                                                                                
         t+=tr+"\n";                                                                                                                                            
        } else // should never happen                                           
                                                                                
        if (res instanceof Components.interfaces.nsIRDFLiteral)                 
        {                                                                                                                                                       
          t+=r + "L: "+res.Value+"\n";                                                                                                                          
        } else                                                                                                                                                  
          t+=r + "?: "+"\n";                                                                                                                                    
      }                                                                                                                                                     
        this.debug(t);                                                                                                                                  
        this.debug('============= show_rdf_ds END =================');                                                                                      
			}   

                                                                                   